VERSION 5.00
Begin VB.Form MainForm 
   Caption         =   "Delcom USB I2C VB Example Ver 0.1 03/14/2003"
   ClientHeight    =   3630
   ClientLeft      =   5295
   ClientTop       =   4215
   ClientWidth     =   7665
   LinkTopic       =   "MainForm"
   ScaleHeight     =   3630
   ScaleWidth      =   7665
   Begin VB.CheckBox I2C_Error 
      Caption         =   "I2C Error"
      Height          =   255
      Left            =   4440
      TabIndex        =   16
      ToolTipText     =   "Set on error, Cleared on new command"
      Top             =   480
      Width           =   1095
   End
   Begin VB.Frame Frame3 
      Caption         =   "Selective Read"
      Height          =   2775
      Left            =   5160
      TabIndex        =   7
      Top             =   720
      Width           =   2415
      Begin VB.TextBox SEL_RESULT 
         Alignment       =   2  'Center
         Height          =   405
         Left            =   120
         TabIndex        =   46
         ToolTipText     =   "The results of the read command. In decimal radix. Ordered from B7 to B0."
         Top             =   1800
         Width           =   2175
      End
      Begin VB.TextBox SEL_CMD 
         Alignment       =   2  'Center
         BeginProperty DataFormat 
            Type            =   1
            Format          =   "0"
            HaveTrueFalseNull=   0
            FirstDayOfWeek  =   0
            FirstWeekOfYear =   0
            LCID            =   1033
            SubFormatType   =   1
         EndProperty
         Height          =   285
         Left            =   1440
         TabIndex        =   44
         Text            =   "000"
         ToolTipText     =   "The selective read command for the device. Valid Range 0-255."
         Top             =   960
         Width           =   735
      End
      Begin VB.TextBox SEL_LEN 
         Alignment       =   2  'Center
         BeginProperty DataFormat 
            Type            =   1
            Format          =   "0"
            HaveTrueFalseNull=   0
            FirstDayOfWeek  =   0
            FirstWeekOfYear =   0
            LCID            =   1033
            SubFormatType   =   1
         EndProperty
         Height          =   285
         Left            =   1440
         TabIndex        =   43
         Text            =   "01"
         ToolTipText     =   "The length of the data bytes to read. Valid Range 0-8"
         Top             =   1320
         Width           =   735
      End
      Begin VB.TextBox SEL_ADD 
         Alignment       =   2  'Center
         BeginProperty DataFormat 
            Type            =   1
            Format          =   "0"
            HaveTrueFalseNull=   0
            FirstDayOfWeek  =   0
            FirstWeekOfYear =   0
            LCID            =   1033
            SubFormatType   =   1
         EndProperty
         Height          =   285
         Left            =   1440
         TabIndex        =   41
         Text            =   "000"
         ToolTipText     =   "The address you want to set. Valid Range 0-255."
         Top             =   600
         Width           =   735
      End
      Begin VB.TextBox SEL_SETUP 
         Alignment       =   2  'Center
         BeginProperty DataFormat 
            Type            =   1
            Format          =   "0"
            HaveTrueFalseNull=   0
            FirstDayOfWeek  =   0
            FirstWeekOfYear =   0
            LCID            =   1033
            SubFormatType   =   1
         EndProperty
         Height          =   285
         Left            =   1440
         TabIndex        =   38
         Text            =   "000"
         ToolTipText     =   "The setup selective read command for the device. Valid Range 0-255."
         Top             =   240
         Width           =   735
      End
      Begin VB.CommandButton SelectiveRead 
         Caption         =   "SelectiveRead"
         Height          =   375
         Left            =   360
         TabIndex        =   10
         ToolTipText     =   "Reads the I2C device using the selective method."
         Top             =   2280
         Width           =   1575
      End
      Begin VB.Label label11 
         Caption         =   "Results B7-B0"
         Height          =   255
         Left            =   120
         TabIndex        =   47
         Top             =   1560
         Width           =   1095
      End
      Begin VB.Label Label10 
         Caption         =   "Sel Command"
         Height          =   255
         Left            =   360
         TabIndex        =   45
         Top             =   960
         Width           =   1095
      End
      Begin VB.Label Label8 
         Caption         =   "Length"
         Height          =   255
         Left            =   840
         TabIndex        =   42
         Top             =   1320
         Width           =   615
      End
      Begin VB.Label Label7 
         Caption         =   "Select Address"
         Height          =   255
         Left            =   240
         TabIndex        =   40
         Top             =   600
         Width           =   1095
      End
      Begin VB.Label Label6 
         Caption         =   "Setup Command"
         Height          =   255
         Left            =   120
         TabIndex        =   39
         Top             =   240
         Width           =   1215
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "Read"
      Height          =   2775
      Left            =   2640
      TabIndex        =   6
      Top             =   720
      Width           =   2415
      Begin VB.TextBox RD_RESULT 
         Alignment       =   2  'Center
         BeginProperty DataFormat 
            Type            =   0
            Format          =   "0"
            HaveTrueFalseNull=   0
            FirstDayOfWeek  =   0
            FirstWeekOfYear =   0
            LCID            =   1033
            SubFormatType   =   0
         EndProperty
         Height          =   375
         Left            =   120
         TabIndex        =   15
         ToolTipText     =   "The results of the read command. In decimal radix. Ordered from B7 to B0."
         Top             =   1560
         Width           =   2175
      End
      Begin VB.TextBox RD_LEN 
         Alignment       =   2  'Center
         BeginProperty DataFormat 
            Type            =   1
            Format          =   "0"
            HaveTrueFalseNull=   0
            FirstDayOfWeek  =   0
            FirstWeekOfYear =   0
            LCID            =   1033
            SubFormatType   =   1
         EndProperty
         Height          =   375
         Left            =   1320
         TabIndex        =   13
         Text            =   "01"
         ToolTipText     =   "The length of the data bytes to read. Valid Range 0-8"
         Top             =   720
         Width           =   615
      End
      Begin VB.TextBox RD_CMD 
         Alignment       =   2  'Center
         BeginProperty DataFormat 
            Type            =   1
            Format          =   "0"
            HaveTrueFalseNull=   0
            FirstDayOfWeek  =   0
            FirstWeekOfYear =   0
            LCID            =   1033
            SubFormatType   =   1
         EndProperty
         Height          =   375
         Left            =   1320
         TabIndex        =   11
         Text            =   "000"
         ToolTipText     =   "Command and/or address byte. The first byte that is sent. Valid Range 0-255."
         Top             =   240
         Width           =   615
      End
      Begin VB.CommandButton Read 
         Caption         =   "Read"
         Height          =   375
         Left            =   600
         TabIndex        =   8
         ToolTipText     =   "Read from the I2C device."
         Top             =   2280
         Width           =   1215
      End
      Begin VB.Label Label5 
         Caption         =   "Results B7-B0"
         Height          =   255
         Left            =   600
         TabIndex        =   37
         Top             =   1320
         Width           =   1335
      End
      Begin VB.Label Label2 
         Caption         =   "Length"
         Height          =   255
         Left            =   360
         TabIndex        =   14
         Top             =   720
         Width           =   615
      End
      Begin VB.Label Label1 
         Caption         =   "Add/Cmd"
         Height          =   255
         Left            =   240
         TabIndex        =   12
         Top             =   360
         Width           =   735
      End
   End
   Begin VB.CommandButton ExitButton 
      Caption         =   "&Exit"
      Height          =   375
      Left            =   6480
      TabIndex        =   0
      ToolTipText     =   "Exit the program."
      Top             =   360
      Width           =   1095
   End
   Begin VB.Frame Frame1 
      Caption         =   "Write"
      Height          =   2775
      Left            =   120
      TabIndex        =   5
      Top             =   720
      Width           =   2415
      Begin VB.TextBox WR_B 
         Height          =   285
         Index           =   7
         Left            =   1680
         TabIndex        =   28
         Text            =   "000"
         ToolTipText     =   "Data Byte 7"
         Top             =   1800
         Width           =   375
      End
      Begin VB.TextBox WR_B 
         Height          =   285
         Index           =   6
         Left            =   1200
         TabIndex        =   27
         Text            =   "000"
         ToolTipText     =   "Data Byte 6"
         Top             =   1800
         Width           =   375
      End
      Begin VB.TextBox WR_B 
         Height          =   285
         Index           =   5
         Left            =   720
         TabIndex        =   26
         Text            =   "000"
         ToolTipText     =   "Data Byte 5"
         Top             =   1800
         Width           =   375
      End
      Begin VB.TextBox WR_B 
         Height          =   285
         Index           =   4
         Left            =   240
         TabIndex        =   25
         Text            =   "000"
         ToolTipText     =   "Data Byte 4"
         Top             =   1800
         Width           =   375
      End
      Begin VB.TextBox WR_B 
         Height          =   285
         Index           =   3
         Left            =   1680
         TabIndex        =   24
         Text            =   "000"
         ToolTipText     =   "Data Byte 3"
         Top             =   1200
         Width           =   375
      End
      Begin VB.TextBox WR_B 
         Height          =   285
         Index           =   2
         Left            =   1200
         TabIndex        =   23
         Text            =   "000"
         ToolTipText     =   "Data Byte 2"
         Top             =   1200
         Width           =   375
      End
      Begin VB.TextBox WR_B 
         Height          =   285
         Index           =   1
         Left            =   720
         TabIndex        =   22
         Text            =   "000"
         ToolTipText     =   "Data Byte 1"
         Top             =   1200
         Width           =   375
      End
      Begin VB.TextBox WR_B 
         Height          =   285
         Index           =   0
         Left            =   240
         TabIndex        =   21
         Text            =   "000"
         ToolTipText     =   "Data Byte 0"
         Top             =   1200
         Width           =   375
      End
      Begin VB.TextBox WR_LEN 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   1320
         TabIndex        =   20
         Text            =   "01"
         ToolTipText     =   "The length of the data bytes to send. Valid Range 0-8"
         Top             =   600
         Width           =   735
      End
      Begin VB.TextBox WR_CMD 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   1320
         TabIndex        =   19
         Text            =   "000"
         ToolTipText     =   "Command and/or address byte. The first byte that is sent. Valid Range 0-255."
         Top             =   240
         Width           =   735
      End
      Begin VB.CommandButton Write 
         Caption         =   "Write"
         Height          =   375
         Left            =   600
         TabIndex        =   9
         ToolTipText     =   "Sends the data to the I2C device."
         Top             =   2280
         Width           =   1095
      End
      Begin VB.Label Label4 
         Caption         =   "B7"
         Height          =   255
         Index           =   7
         Left            =   1800
         TabIndex        =   36
         Top             =   1560
         Width           =   255
      End
      Begin VB.Label Label4 
         Caption         =   "B6"
         Height          =   255
         Index           =   6
         Left            =   1320
         TabIndex        =   35
         Top             =   1560
         Width           =   255
      End
      Begin VB.Label Label4 
         Caption         =   "B5"
         Height          =   255
         Index           =   5
         Left            =   840
         TabIndex        =   34
         Top             =   1560
         Width           =   255
      End
      Begin VB.Label Label4 
         Caption         =   "B4"
         Height          =   255
         Index           =   4
         Left            =   360
         TabIndex        =   33
         Top             =   1560
         Width           =   255
      End
      Begin VB.Label Label4 
         Caption         =   "B3"
         Height          =   255
         Index           =   3
         Left            =   1800
         TabIndex        =   32
         Top             =   960
         Width           =   255
      End
      Begin VB.Label Label4 
         Caption         =   "B2"
         Height          =   255
         Index           =   2
         Left            =   1320
         TabIndex        =   31
         Top             =   960
         Width           =   255
      End
      Begin VB.Label Label4 
         Caption         =   "B1"
         Height          =   255
         Index           =   1
         Left            =   840
         TabIndex        =   30
         Top             =   960
         Width           =   255
      End
      Begin VB.Label Label4 
         Caption         =   "B0"
         Height          =   255
         Index           =   0
         Left            =   360
         TabIndex        =   29
         Top             =   960
         Width           =   255
      End
      Begin VB.Label Length 
         Caption         =   "Length"
         Height          =   255
         Left            =   240
         TabIndex        =   18
         Top             =   600
         Width           =   615
      End
      Begin VB.Label Label3 
         Caption         =   "Add/Cmd"
         Height          =   255
         Left            =   120
         TabIndex        =   17
         Top             =   240
         Width           =   735
      End
   End
   Begin VB.Label Label9 
      Caption         =   "DeviceName:"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   120
      Width           =   975
   End
   Begin VB.Label Version 
      Caption         =   "Version"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   480
      Width           =   1815
   End
   Begin VB.Label SerialNumber 
      Caption         =   "Serial Number"
      Height          =   255
      Left            =   2160
      TabIndex        =   2
      Top             =   480
      Width           =   1815
   End
   Begin VB.Label DeviceNameLabel 
      Caption         =   "Device Name"
      Height          =   255
      Left            =   1200
      TabIndex        =   1
      Top             =   120
      Width           =   6735
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Delcom USB I2C VB Example Code
' MainForm 0.1 03/21/2003
' Delcom Engineering Copyright 2003  - www.delcom-eng.com
' This code makes function calls to the VB_BAS.bas file.
' Release Notes:
' V0.1 03/20/03 - Initial Release
                



' Closes the device on exit
Private Sub ExitButton_Click()
Dim Status As Boolean
Status = CloseDevice()      ' close device

End
End Sub

' Initialize the program
Private Sub Form_Load()
Dim Status As Long
Dim Packet As PacketStructure
Dim Ret As RetPacketStructure

Status = OpenDevice()       ' Gets the device name and opens the device

If Status = 0 Then          ' Check for errors
    Status = CloseDevice()  ' if errors exit
    End
Else
    DeviceNameLabel.Caption = VB_USB.lpDeviceName ' Displays the device Name
    Packet.MajorCmd = 11
    Packet.MinorCmd = 10
    Packet.DataLSB = 0
    Packet.DataMSB = 0
    Packet.Length = 0
    Ret = SendPacket(Packet) ' Get the Version infomation
    SerialNumber.Caption = "SerialNumber: " & ((Ret.B3 * &H1000000) + (Ret.B2 * &H10000) + (Ret.B1 * &H100) + (Ret.B0))
    Version.Caption = "Version: " & Ret.B4 & "  " & Ret.B6 & "/" & Ret.B5 & "/" & (2000 + Ret.B7)
    
    If Ret.B4 < 6 Then
        MsgBox ("WARNING: USBIODS version does not support I2C")
    End If
        
End If

'Timer1.Interval = 100       ' Set timer to 100 mSecond interval
'Timer1.Enabled = True       ' Enable the timer
End Sub




' Read the I2C device with add/cmd and data length
Private Sub Read_Click()

On Error GoTo ERROR_HANDLER

Dim Packet As PacketStructure
Dim Ret As RetPacketStructure
Dim Length As Long
    
    Length = RD_LEN.Text
    If Length > 8 Then
        RD_LEN.Text = 8
        Length = 8
    End If
    
    Packet.MajorCmd = 11
    Packet.MinorCmd = 60
    Packet.DataLSB = RD_CMD.Text        ' set the add/cmd
    Packet.DataMSB = Length             ' set the length
    Packet.Length = 0
    Ret = SendPacket(Packet)  ' Send the Packet
    
    RD_RESULT.Text = ""
    If Length > 0 Then
        RD_RESULT.Text = Ret.B0
    End If
    If Length > 1 Then
        RD_RESULT.Text = RD_RESULT.Text & " " & Ret.B1
    End If
    If Length > 2 Then
        RD_RESULT.Text = RD_RESULT.Text & " " & Ret.B2
    End If
    If Length > 3 Then
        RD_RESULT.Text = RD_RESULT.Text & " " & Ret.B3
    End If
    If Length > 4 Then
        RD_RESULT.Text = RD_RESULT.Text & " " & Ret.B4
    End If
    If Length > 5 Then
        RD_RESULT.Text = RD_RESULT.Text & " " & Ret.B5
    End If
    If Length > 6 Then
        RD_RESULT.Text = RD_RESULT.Text & " " & Ret.B6
    End If
    If Length > 7 Then
        RD_RESULT.Text = RD_RESULT.Text & " " & Ret.B7
    End If
        
        
        
    Call Check4Errors
        
Exit Sub                            ' Exit Sub
ERROR_HANDLER:
    MsgBox "ReadI2C()ERROR #" & Str$(Err) & " : " & Error & Chr(13)
End Sub


' checks for any I2C errors
Public Sub Check4Errors()
Dim Packet As PacketStructure
Dim Ret As RetPacketStructure
    
On Error GoTo ERROR_HANDLER

    Packet.MajorCmd = 11
    Packet.MinorCmd = 9
    Packet.Length = 0
    Ret = SendPacket(Packet)  ' Send the Packet
    
    If (CInt(Ret.B7) And CInt(&H80)) Then
        I2C_Error.Value = 1
    Else
        I2C_Error.Value = 0
    End If
Exit Sub                            ' Exit Sub
ERROR_HANDLER:
    MsgBox "Check4Error() ERROR #" & Str$(Err) & " : " & Error & Chr(13)
    

End Sub
' Reads the I2C port using the selective mothod
Private Sub SelectiveRead_Click()
On Error GoTo ERROR_HANDLER

Dim Packet As PacketStructure
Dim Ret As RetPacketStructure
Dim Length As Long
    
    Length = SEL_LEN.Text
    If Length > 8 Then
        SEL_LEN.Text = 8
        Length = 8
    End If
        
    ' First setup the selective command
    Packet.MajorCmd = 10
    Packet.MinorCmd = 61
    Packet.DataLSB = SEL_SETUP.Text        ' set the cmd
    Packet.DataMSB = SEL_ADD               ' set the address
    Packet.Length = 0
    Ret = SendPacket(Packet)  ' Send the Packet
    
    ' Then read the device
    Packet.MajorCmd = 11
    Packet.MinorCmd = 61
    Packet.DataLSB = SEL_CMD.Text        ' set the add/cmd
    Packet.DataMSB = Length             ' set the length
    Packet.Length = 0
    Ret = SendPacket(Packet)  ' Send the Packet
    
    SEL_RESULT.Text = ""
    If Length > 0 Then
        SEL_RESULT.Text = Ret.B0
    End If
    If Length > 1 Then
        SEL_RESULT.Text = SEL_RESULT.Text & " " & Ret.B1
    End If
    If Length > 2 Then
        SEL_RESULT.Text = SEL_RESULT.Text & " " & Ret.B2
    End If
    If Length > 3 Then
        SEL_RESULT.Text = SEL_RESULT.Text & " " & Ret.B3
    End If
    If Length > 4 Then
        SEL_RESULT.Text = SEL_RESULT.Text & " " & Ret.B4
    End If
    If Length > 5 Then
        SEL_RESULT.Text = SEL_RESULT.Text & " " & Ret.B5
    End If
    If Length > 6 Then
        SEL_RESULT.Text = SEL_RESULT.Text & " " & Ret.B6
    End If
    If Length > 7 Then
        SEL_RESULT.Text = SEL_RESULT.Text & " " & Ret.B7
    End If
        
        
        
    Call Check4Errors
        
Exit Sub                            ' Exit Sub
ERROR_HANDLER:
    MsgBox "ReadSelectiveI2C()ERROR #" & Str$(Err) & " : " & Error & Chr(13)

End Sub

' writes length bytes to add/cmd I2C port
Private Sub Write_Click()
On Error GoTo ERROR_HANDLER

Dim Packet As PacketStructure
Dim Ret As RetPacketStructure
Dim Length As Long
    
    Length = WR_LEN.Text
    If Length > 8 Then
        WR_LEN.Text = 8
        Length = 8
    End If
    
    Packet.MajorCmd = 10
    Packet.MinorCmd = 60
    Packet.DataLSB = WR_CMD.Text        ' set the add/cmd
    Packet.DataMSB = Length             ' set the length
    Packet.Length = Length
    Packet.DataExt(0) = WR_B(0)
    Packet.DataExt(1) = WR_B(1)
    Packet.DataExt(2) = WR_B(2)
    Packet.DataExt(3) = WR_B(3)
    Packet.DataExt(4) = WR_B(4)
    Packet.DataExt(5) = WR_B(5)
    Packet.DataExt(6) = WR_B(6)
    Packet.DataExt(7) = WR_B(7)
    Ret = SendPacket(Packet)  ' Send the Packet
    
      
    Call Check4Errors
        
Exit Sub                            ' Exit Sub
ERROR_HANDLER:
    MsgBox "WriteI2C() ERROR #" & Str$(Err) & " : " & Error & Chr(13)

End Sub
